"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generate = void 0;
const listr2_1 = require("listr2");
const clientTasks_1 = require("./tasks/clientTasks");
const schemaTask_1 = require("./tasks/schemaTask");
const generate = (config) => {
    if (!config.output) {
        throw new Error('`output` must be defined in the config');
    }
    return new listr2_1.Listr([
        {
            title: `generating the client in \`${config.output}\``,
            task: () => new listr2_1.Listr([(0, schemaTask_1.schemaTask)(config), ...(0, clientTasks_1.clientTasks)(config)]),
        },
    ], { renderer: config.verbose ? 'verbose' : 'default', exitOnError: true })
        .run()
        .catch((e) => {
        var _a;
        // cconsole.log(e)
        throw (_a = e === null || e === void 0 ? void 0 : e.errors) === null || _a === void 0 ? void 0 : _a[0];
    });
};
exports.generate = generate;
//# sourceMappingURL=main.js.map