"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.renderTyping = void 0;
const graphql_1 = require("graphql");
const renderTyping = (type, nonNull = false, wrap = (x) => x) => {
    if ((0, graphql_1.isNamedType)(type)) {
        let typeName = type.name;
        // if is a scalar use the scalar interface to not expose reserved words
        if ((0, graphql_1.isScalarType)(type)) {
            typeName = `Scalars['${typeName}']`;
        }
        const typing = wrap(typeName);
        return nonNull ? typing : `(${typing} | null)`;
    }
    if ((0, graphql_1.isListType)(type)) {
        const typing = `${(0, exports.renderTyping)(type.ofType, false, wrap)}[]`;
        return nonNull ? typing : `(${typing} | null)`;
    }
    return (0, exports.renderTyping)(type.ofType, true, wrap);
};
exports.renderTyping = renderTyping;
//# sourceMappingURL=renderTyping.js.map