"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.unionType = void 0;
const uniq_1 = __importDefault(require("lodash/uniq"));
const unionType = (type, _) => {
    const types = type.getTypes();
    const typeObj = types.reduce((r, t) => {
        r[`on_${t.name}`] = { type: t.name };
        return r;
    }, {});
    const commonInterfaces = (0, uniq_1.default)(types.map((x) => x.getInterfaces()).flat());
    commonInterfaces.forEach((t) => {
        typeObj[`on_${t.name}`] = { type: t.name };
    });
    typeObj.__typename = { type: 'String' };
    return typeObj;
};
exports.unionType = unionType;
//# sourceMappingURL=unionType.js.map