"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.capitalize = exports.camelCase = void 0;
const camelCase_1 = __importDefault(require("lodash/camelCase"));
function camelCase(str) {
    if (!str)
        return str;
    // keep leading _
    if (str.startsWith('_')) {
        const leadingChars = str.match(/^_+/);
        return (leadingChars[0] +
            (0, camelCase_1.default)(str.slice(leadingChars[0].length)));
    }
    if (str.endsWith('_')) {
        const leadingChars = str.match(/_+$/);
        return ((0, camelCase_1.default)(str.slice(0, str.length - leadingChars[0].length)) + leadingChars[0]);
    }
    return (0, camelCase_1.default)(str);
}
exports.camelCase = camelCase;
function capitalize(str) {
    if (!str)
        return str;
    return str.charAt(0).toUpperCase() + str.slice(1);
}
exports.capitalize = capitalize;
//# sourceMappingURL=utils.js.map